<template>
  <div class="formActBtn">
    <template v-if="activities">
      <template v-if="activities.length == 1">
        <!-- 当为1个按钮时 -->
        <mt-button 
          :class="[priorityBtn[0] && priorityBtn[0].type == 3?'delBtn':'']" 
          type="primary" 
          :disabled="priorityBtn[0]?priorityBtn[0].readonly:''"
          @click="onClick(priorityBtn[0])"
        >
          <i v-if="priorityBtn[0] && priorityBtn[0].icon && JSON.parse(priorityBtn[0].icon).type == 'font'" 
            :class="JSON.parse(priorityBtn[0].icon).icon" />
          <img class="btn-img" v-if="priorityBtn[0] && priorityBtn[0].icon && JSON.parse(priorityBtn[0].icon).type == 'img'" 
            :src="priorityBtn[0] && priorityBtn[0].icon ? $Constant.contextPath + '/uploads/lib/icon' + JSON.parse(priorityBtn[0].icon).icon : ''"/>
          <span>{{priorityBtn[0] ? priorityBtn[0].name : ''}}</span>
        </mt-button>
      </template>

      <template v-else-if="activities.length == 2">
        <!-- 当为2个按钮时 -->
        <mt-button
          v-for="(act, i) in priorityBtn"
          :key = i 
          type="primary"
          :plain="i>0?true:false"  
          :class="[act.type == 3?'delBtn':'','ml-1']" 
          :disabled="act.readonly"
          @click="onClick(act)"
        >
          <i v-if="act.icon && JSON.parse(act.icon).type == 'font'" 
            :class="JSON.parse(act.icon).icon" />
          <img class="btn-img" v-if="act.icon && JSON.parse(act.icon).type == 'img'" 
            :src="$Constant.contextPath + '/uploads/lib/icon' + JSON.parse(act.icon).icon"/>
          <span>{{act.name}}</span>
        </mt-button>
      </template>

      <template v-else-if="activities.length == 3">
        <!-- 当为3个按钮时 -->
        <mt-button
          v-for="(act, i) in priorityBtn"
          :key = i 
          type="primary"
          :plain="i>0?true:false"  
          :class="[act.type == 3?'delBtn':'', 'ml-1']"
          :disabled="act.readonly"
          @click="onClick(act)"
        >
          <i v-if="act.icon && JSON.parse(act.icon).type == 'font'" 
            :class="JSON.parse(act.icon).icon" />
          <img class="btn-img" v-if="act.icon && JSON.parse(act.icon).type == 'img'" 
            :src="$Constant.contextPath + '/uploads/lib/icon' + JSON.parse(act.icon).icon"/>
          <span>{{act.name}}</span>
        </mt-button>
      </template>
      <template v-if="activities.length > 3">
        <!-- 当为3个以上按钮时 -->
        <mt-button
          :class="[activities[0].type == 3?'moreDelBtn':'', 'ml-1']" 
          type="primary" 
          :disabled="activities[0].readonly"
          @click="onClick(activities[0])"
        >
          <i v-if="activities[0].icon && JSON.parse(activities[0].icon).type == 'font'" 
            :class="JSON.parse(activities[0].icon).icon" />
          <img class="btn-img" v-if="activities[0].icon && JSON.parse(activities[0].icon).type == 'img'" 
            :src="$Constant.contextPath + '/uploads/lib/icon' + JSON.parse(activities[0].icon).icon"/>
          <span>{{activities[0].name}}</span>
        </mt-button>
        
        <mt-button
          :class="[activities[1].type == 3?'moreDelBtn':'', 'ml-1']" 
          type="primary" 
          :disabled="activities[1].readonly"
          @click="onClick(activities[1])"
        >
          <i v-if="activities[1].icon && JSON.parse(activities[1].icon).type == 'font'" 
            :class="JSON.parse(activities[1].icon).icon" />
          <img class="btn-img" v-if="activities[1].icon && JSON.parse(activities[1].icon).type == 'img'" 
            :src="$Constant.contextPath + '/uploads/lib/icon' + JSON.parse(activities[1].icon).icon"/>
          <span>{{activities[1].name}}</span>
        </mt-button>
        <mt-button 
          type="primary" 
          @click.stop plain 
          @click="onBtnMoreClick"
        >{{$t('more')}}</mt-button>
        <div v-show="showMoreBtns" >
          <div  class="moreBtn-popup">
            <template v-for="(act,i) in activities">
              <a v-if="i >1" :key="act.id + act.name" class="btn-pop" @click="onClick(act)"> 
                <i v-if="act.icon && JSON.parse(act.icon).type == 'font'" :class="JSON.parse(act.icon).icon" />
                <img class="btn-img" v-if="act.icon && JSON.parse(act.icon).type == 'img'" :src="$Constant.contextPath + '/uploads/lib/icon' + JSON.parse(act.icon).icon"/>
                <span>{{act.name}}</span>
              </a>
            </template>
            <div v-show="showMoreBtns" class="border-down-empty">
            <span></span>
          </div>
          </div>
        </div>
      </template>
    </template>
  </div>
</template>
<script>
export default {
  props: [
    "activities",
    "math",
    "viewType", 
    "viewPage"
  ],

  data: function() {
    return {
      priorityBtn:[],
      showMoreBtns: false,
    };
  },
  watch: {
    activities() {
      this.hideSomeButtons();
    },
    math(){
      this.mathRom();
    }
  },
  mounted() {
    this.setViewPageBtn();
  },
  methods: {
    //设置视图的新建（2）、删除（3）按钮优先显示
    setViewPageBtn() {
      if(this.viewPage) {
         if(this.activities) {
          let actArr = JSON.parse(JSON.stringify(this.activities));
          let priorityBtn = [];
          for(let j=0; j<actArr.length; j++) {
            if(actArr[j].type == 2) {
              priorityBtn.unshift(actArr[j]);
              actArr.splice(j, 1); 
              j--; 
            }else if(actArr[j].type == 3) {
              priorityBtn.push(actArr[j]);
              actArr.splice(j, 1); 
              j--; 
            }
          }
          if(priorityBtn.length > 0) {
            priorityBtn = priorityBtn.concat(actArr);
          }else {
            priorityBtn = actArr;
          }
          this.priorityBtn = priorityBtn;
        }
      }
    },
    hideSomeButtons() {
      if(this.activities) {
        for (var i = 0; i < this.activities.length; i++) {
          if (
              this.activities[i].type == 8  || //关闭窗口
              //this.activities[i].type == 20 || //批量提交  暂时先屏蔽
            //this.activities[i].type == 13 || //发送微信消息(发送邮件)
              this.activities[i].type == 14 || //网页打印
              this.activities[i].type == 15 || //打印包含流程历史
              this.activities[i].type == 16 || //excel导出
              this.activities[i].type == 25 || //PDF导出
              this.activities[i].type == 26 || //文件下载
              this.activities[i].type == 27 || //excel导入
              this.activities[i].type == 30 || //自定义打印
              // this.activities[i].type == 33 || //流程启动
              this.activities[i].type == 36 || //网页打印
              // this.activities[i].type == 43 || //跳转
              this.activities[i].type == 46  //签章
              // this.activities[i].type == 1     //刷新
            ) { //文件下载
              this.activities.splice(i, 1); 
              i--; 
          }

        }
        if(this.activities) {
          //流程处理（提交）5、返回10
          let actArr = JSON.parse(JSON.stringify(this.activities));
          let priorityBtn = [];
          for(let j=0; j<actArr.length; j++) {
            if(actArr[j].type == 5) {
              priorityBtn.unshift(actArr[j]);
              actArr.splice(j, 1); 
              j--; 
            }else if(actArr[j].type == 10) {
              priorityBtn.push(actArr[j]);
              actArr.splice(j, 1); 
              j--; 
            }
          }
          if(priorityBtn.length > 0) {
            priorityBtn = priorityBtn.concat(actArr);
          }else {
            priorityBtn = actArr;
          }
          this.priorityBtn = priorityBtn;
        }
        
      }
      
    },
    mathRom(){
      if(this.math){
        this.showMoreBtns = false;
      }
    },
    onBtnMoreClick() {
      this.showMoreBtns = !this.showMoreBtns;
    },
    onClick(act) {
      if(!act.readonly) {
        this.onAction(act);
      }
    },

    onAction(act) {
      let activityType = act.type;
      switch (act.type) {
        case 1: //载入视图
          this.$emit("action",act);
          break;
        case 2: //创建
          this.$emit("action",act);
          // this.$parent.doCreate(act);
          break;
        case 3: //删除
          this.$emit("action",act);
          break;
        case 4: //保存并启动流程
          act.flowType = '1';
          this.$emit("action",act);
          break;
        case 5: //流程处理
          act.flowType = '80';
          this.$emit("action",act);
          break;
        case 8: //关闭窗口
          this.$parent.runBeforeAction(act.id, "", "", activityType);
          break;
        case 10: //返回
          //this.$parent.$parent.doBack();
          this.$emit("action",act);
          //this.$parent.goBack();
          break;
        case 11: //保存并返回
          this.$parent.runBeforeAction(act.id, "", "", activityType,act);
          break;
        case 13: //无
          this.$emit("action",act);
          break;
        case 14: //网页打印(表单)
          this.$parent.runBeforeAction(act.id, "", "", activityType);
          break;
        case 15: //网页打印含历史
          this.$parent.runBeforeAction(act.id, "", "", activityType);
          break;
        case 16: //导出excel
          break;
        case 19: //保存草稿不校检
          //this.$parent.saveDraft();
          this.$parent.runBeforeAction(act.id, "", "", activityType);
          break;
        case 18: //清空所有数据
          this.$emit("action",act);
          break;
        case 20: //批量提交
          act.flowType = '80';
          this.$emit("action",act);
          break;
        case 21: //保存并复制
          this.$parent.runBeforeAction(act.id, "", "", activityType);
          break;
        case 25: //PDF导出
          this.$parent.runBeforeAction(act.id, "", "", activityType);
          break;
        case 26: //文件下载
          this.$parent.runBeforeAction(act.id, "", "", activityType);
          break;
        case 27: //导入excel
          break;
        case 28: //电子签章
          this.$emit("action",act);
          break;
        case 29: //批量签章
          break;
        case 33: //流程启动
          act.flowType = '1';
          this.$emit("action",act);
          break;
        case 34: //保存
          //this.$parent.doSave();
          // this.$parent.runBeforeAction(act.id, "", "", activityType);
          this.$emit("action",act);
          break;
        case 36: //网页打印(视图)
          break;
        case 37: //邮件短信分享
          break;
        case 42: //保存并新建
          this.$parent.runBeforeAction(act.id, "", "", activityType);
          break;
        case 43: //跳转
          this.$emit("action",act);
          break;
        case 45: //归档
          this.$parent.runBeforeAction(act.id, "", "", activityType);
          break;
        case 46: //签章
          break;
        case 47: //回退流程
          this.$emit("action",act);
          break;
        case 48: //催办流程
          this.$emit("action",act);
          break;
        case 49: //挂起流程
          act.flowType = '88';
          this.$emit("action", act);
          break;
        case 50: //恢复流程
          act.flowType = '89';
          this.$emit("action", act);
          break;
        case 51: //回撤流程
          act.flowType = '85';
          this.$emit("action", act);
          break;
        case 52: //终止流程
          act.flowType = '8';
          this.$emit("action", act);
          break;
        case 53: //编辑流程审批人
          this.$emit("action", act);
          break;
        case 54: //调整流程
          break;
        case 55: //点评
          this.$emit("action", act);
          break;
        case 56: //补签
          this.$emit("action", act);
          break;
        case 57: //加签主办
          this.$emit("action", act);
          break;
        case 58: //加签协办
          this.$emit("action", act);
          break;
        default:
          break;
      }
    }
  }
};
</script>


